/*******************************************************************************
 *
 * winperror.c
 *
 * part of ext2 NT tools
 *
 * Copyright (C) Peeter Joot, 1997
 *
 * This file may be redistributed under the terms of the GNU Public License.
 ******************************************************************************/

#include "winperror.h"
#include <windows.h>
#include <stdio.h>
#include <stdarg.h>

unsigned winperror(char * message, ...)
{
	LPVOID lpMsgBuf;
	va_list ap;

	DWORD error = GetLastError();
	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM
		, NULL
		, error
		, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT)
		, (LPTSTR) &lpMsgBuf
		, 0
		, NULL 
		);

	va_start(ap, message);
	vfprintf(stderr, message, ap);
	va_end(ap);

	fprintf(stderr, " : error = %lu -- %s", error, lpMsgBuf);
	LocalFree( lpMsgBuf );
	return error;
}
